Home | History | Annotate | Download | only in test
      1 #!/bin/bash
      2 #
      3 # Copyright (C) 2007 The Android Open Source Project
      4 #
      5 # Licensed under the Apache License, Version 2.0 (the "License");
      6 # you may not use this file except in compliance with the License.
      7 # You may obtain a copy of the License at
      8 #
      9 #     http://www.apache.org/licenses/LICENSE-2.0
     10 #
     11 # Unless required by applicable law or agreed to in writing, software
     12 # distributed under the License is distributed on an "AS IS" BASIS,
     13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     14 # See the License for the specific language governing permissions and
     15 # limitations under the License.
     16 
     17 # Set up prog to be the path of this script, including following symlinks,
     18 # and set up progdir to be the fully-qualified pathname of its directory.
     19 prog="$0"
     20 while [ -h "${prog}" ]; do
     21     newProg=`/bin/ls -ld "${prog}"`
     22     newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
     23     if expr "x${newProg}" : 'x/' >/dev/null; then
     24         prog="${newProg}"
     25     else
     26         progdir=`dirname "${prog}"`
     27         prog="${progdir}/${newProg}"
     28     fi
     29 done
     30 oldwd=`pwd`
     31 progdir=`dirname "${prog}"`
     32 cd "${progdir}"
     33 progdir=`pwd`
     34 prog="${progdir}"/`basename "${prog}"`
     35 
     36 run_args=""
     37 usage="no"
     38 sequental="no"
     39 
     40 while true; do
     41     if [ "x$1" = "x--host" ]; then
     42         run_args="${run_args} --host"
     43         shift
     44     elif [ "x$1" = "x--jvm" ]; then
     45         run_args="${run_args} --jvm"
     46         shift
     47     elif [ "x$1" = "x--debug" ]; then
     48         run_args="${run_args} --debug"
     49         shift
     50     elif [ "x$1" = "x--zygote" ]; then
     51         run_args="${run_args} --zygote"
     52         shift
     53     elif [ "x$1" = "x--interpreter" ]; then
     54         run_args="${run_args} --interpreter"
     55         shift
     56     elif [ "x$1" = "x--no-verify" ]; then
     57         run_args="${run_args} --no-verify"
     58         shift
     59     elif [ "x$1" = "x--no-optimize" ]; then
     60         run_args="${run_args} --no-optimize"
     61         shift
     62     elif [ "x$1" = "x--valgrind" ]; then
     63         run_args="${run_args} --valgrind"
     64         shift
     65     elif [ "x$1" = "x--dev" ]; then
     66         run_args="${run_args} --dev"
     67         shift
     68     elif [ "x$1" = "x--update" ]; then
     69         run_args="${run_args} --update"
     70         shift
     71     elif [ "x$1" = "x--help" ]; then
     72         usage="yes"
     73         shift
     74     elif [ "x$1" = "x--seq" ]; then
     75         sequental="yes"
     76         shift
     77     elif [ "x$1" = "x-O" ]; then
     78         run_args="${run_args} -O"
     79         shift
     80     elif [ "x$1" = "x--64" ]; then
     81         run_args="${run_args} --64"
     82         shift
     83     elif [ "x$1" = "x--trace" ]; then
     84         run_args="${run_args} --trace"
     85         shift
     86     elif [ "x$1" = "x--relocate" ]; then
     87         run_args="${run_args} --relocate"
     88         shift
     89     elif [ "x$1" = "x--no-relocate" ]; then
     90         run_args="${run_args} --no-relocate"
     91         shift
     92     elif [ "x$1" = "x--no-prebuild" ]; then
     93         run_args="${run_args} --no-prebuild"
     94         shift;
     95     elif [ "x$1" = "x--prebuild" ]; then
     96         run_args="${run_args} --prebuild"
     97         shift;
     98     elif [ "x$1" = "x--always-clean" ]; then
     99         run_args="${run_args} --always-clean"
    100     elif expr "x$1" : "x--" >/dev/null 2>&1; then
    101         echo "unknown $0 option: $1" 1>&2
    102         usage="yes"
    103         break
    104     else
    105         break
    106     fi
    107 done
    108 
    109 if [ "$usage" = "yes" ]; then
    110     prog=`basename $prog`
    111     (
    112         echo "usage:"
    113         echo "  $prog --help     Print this message."
    114         echo "  $prog [options]  Run all tests with the given options."
    115         echo "  Options are all passed to run-test; refer to that for " \
    116              "further documentation:"
    117         echo "    --debug --dev --host --interpreter --jvm --no-optimize"
    118         echo "    --no-verify -O --update --valgrind --zygote --64 --relocate"
    119         echo "    --prebuild --always-clean"
    120         echo "  Specific Runtime Options:"
    121         echo "    --seq                Run tests one-by-one, avoiding failures caused by busy CPU"
    122     ) 1>&2
    123     exit 1
    124 fi
    125 
    126 if [ "$sequental" == "yes" ]; then
    127   i=0
    128   for test_name in *; do
    129     if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
    130       ./run-test ${run_args} "$test_name"
    131       RES=$?
    132       test_pids[i]=i
    133       test_names[test_pids[i]]="$test_name"
    134       if [ "$RES" != "0" ]; then
    135         let failure_count+=1
    136         failed_test_names="$failed_test_names ${test_names[i]}"
    137       else
    138         let succeeded_count+=1
    139       fi
    140       let i+=1
    141     fi
    142   done
    143 else
    144   # start all the tests
    145   i=0
    146   for test_name in *; do
    147     if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
    148       ./run-test ${run_args} "$test_name" &
    149       test_pids[i]=$!
    150       test_names[test_pids[i]]="$test_name"
    151       let i+=1
    152     fi
    153   done
    154 
    155   # wait for all the tests, collecting the failures
    156   failure_count=0
    157   succeeded_count=0
    158   failed_test_names=""
    159   for pid in ${test_pids[@]}; do
    160     wait $pid
    161     if [ "$?" != "0" ]; then
    162       let failure_count+=1
    163       failed_test_names="$failed_test_names ${test_names[$pid]}[pid=$pid]"
    164     else
    165       let succeeded_count+=1
    166     fi
    167   done
    168 fi
    169 
    170 echo "succeeded tests: $succeeded_count"
    171 echo "failed tests: $failure_count"
    172 
    173 for i in $failed_test_names; do
    174   echo "failed: $i"
    175 done
    176